All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
PNotifierTemplate< ParmType > Class Template Reference

The `PNotifier` and `PNotifierFunction` classes build a completely type safe mechanism for calling arbitrary member functions on classes. More...

`#include <notifier.h>`

Inheritance diagram for PNotifierTemplate< ParmType >:

## Public Member Functions

| PNotifierTemplate (PNotifierFunctionTemplate< ParmType > *func=NULL)
| Create a new notification function smart pointer. More...
virtual void | operator() (PObject &notifier, ParmType extra) const
| Execute the call to the actual notification function on the object instance contained in this object. More...
Public Member Functions inherited from PSmartPointer
| PSmartPointer (PSmartObject *obj=NULL)
| Create a new smart pointer instance and have it point to the specified `PSmartObject` instance. More...
| PSmartPointer (const PSmartPointer &ptr)
| Create a new smart pointer and point it at the data pointed to by the `ptr` parameter. More...
virtual | ~PSmartPointer ()
| Destroy the smart pointer and decrement the reference count on the object being pointed to. More...
PSmartPointer & | operator= (const PSmartPointer &ptr)
| Assign this pointer to the value specified in the `ptr` parameter. More...
virtual Comparison | Compare (const PObject &obj) const
| Determine the relative rank of the pointers. More...
PBoolean | IsNULL () const
| Determine if the smart pointer has been set to point to an actual object instance. More...
PSmartObject * | GetObject () const
| Get the current value if the internal smart object pointer. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Additional Inherited Members

Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Protected Attributes inherited from PSmartPointer
PSmartObject * | object
| Object the smart pointer points to. More...

## Detailed Description

### template<typename ParmType>
class PNotifierTemplate< ParmType >

The `PNotifier` and `PNotifierFunction` classes build a completely type safe mechanism for calling arbitrary member functions on classes.

The "pointer to a member function" capability built into C++ makes the assumption that the function name exists in an ancestor class. If you wish to call a member function name that does {not} exist in any ancestor class, very type unsafe casting of the member functions must be made. Some compilers will even refuse to do it at all!

To overcome this problem, as this mechanism is highly desirable for callback functions in the GUI part of the PTLib library, these classes and a macro are used to create all the classes and declarations to use polymorphism as the link between the caller, which has no knowledege of the function, and the receiver object and member function.

This is most often used as the notification of actions being take by interactors in the PTLib library.

## Constructor & Destructor Documentation

template<typename ParmType>

PNotifierTemplate< ParmType >::PNotifierTemplate | ( | PNotifierFunctionTemplate< ParmType > * | func = `NULL` | ) |

inline

Create a new notification function smart pointer.

Parameters

  func | Notifier function to call.

## Member Function Documentation

template<typename ParmType>

virtual void PNotifierTemplate< ParmType >::operator() | ( | PObject & | notifier,
|  | ParmType | extra
| ) |  | const

inline virtual

Execute the call to the actual notification function on the object instance contained in this object.

This will make a polymorphic call to the function declared by the `PDECLARE_NOTIFIER` macro which in turn calls the required function in the destination object.

Parameters

  notifier | Object that is making the notification.
  extra | Extra information that may be passed to function.

The documentation for this class was generated from the following file:

- notifier.h